'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.writeToFileIfChanged = undefined;

var _gracefulFs = require('graceful-fs');

var _gracefulFs2 = _interopRequireDefault(_gracefulFs);

var _crypto = require('crypto');

var _crypto2 = _interopRequireDefault(_crypto);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var writeToFileIfChanged = exports.writeToFileIfChanged = function writeToFileIfChanged(filename, content) {
  try {
    var currentInput = _gracefulFs2.default.readFileSync(filename, 'utf-8');
    var oldHash = _crypto2.default.createHash('md5').update(currentInput).digest('hex');
    var newHash = _crypto2.default.createHash('md5').update(content).digest('hex');
    // the definitions haven't changed - ignore this
    if (oldHash === newHash) {
      return false;
    }
  } finally {
    _gracefulFs2.default.writeFileSync(filename, content);
  }
};